function effective(name, props, n, limits, isline)

% read the whole data with ALL features
data1 = textread(strcat(name,'.nn1')); % nn 
data2 = textread(strcat('eigs_',name,'.txt')); % eigs

alldata = [data1 abs(data2(:,2:3))];

noids = alldata(:,2:size(alldata,2));
justids = alldata(:,1);


outlierness = textread(strcat(name,'_',num2str(props(1)),'_',num2str(props(2)), '_finalscore'));
outlierness = outlierness(:,2);

% find max n outliers
ind = zeros(n,1);
lof = zeros(n,1);

[lofd, indd] = max(outlierness);
ind(1) = indd(1);
lof(1) = lofd(1);

indd = find(outlierness == lof(1));
outlierness(indd) = 0;

no=2;
while(1)    
    [lofd, indd] = max(outlierness);
    ind(no) = indd(1);
    lof(no) = lofd(1);
    
    indd = find(outlierness == lof(no));
    outlierness(indd) = 0;
    
    if (lof(no) ~= lof(no-1))
        no = no+1;
        if(no == n+1)
            break;
        end
    end
    
end




outliernesspl = textread( strcat(name,'_',num2str(props(1)),'_',num2str(props(2)),'_scores_l'));
outliernesspl = outliernesspl(:,2);

% find max n outliers
indpl = [];
lofpl = zeros(n,1);
indpl_sin = zeros(n,1);

[lofd, indd] = max(outliernesspl);
lofpl(1) = lofd(1);
indpl_sin(1) = indd(1);

indd = find(outliernesspl == lofpl(1));
outliernesspl(indd) = 0;

indpl = [indpl; indd];

no=2;
while(1)    
    [lofd, indd] = max(outliernesspl);
    lofpl(no) = lofd(1);
    indpl_sin(no) = indd(1);
    
    indd = find(outliernesspl == lofpl(no));
    outliernesspl(indd) = 0;
    
    indpl = [indpl; indd];
    
    if (lof(no) ~= lof(no-1))
        no = no+1;
        if(no == n+1)
            break;
        end
    end
    
end

% 
% fidn = fopen( strcat('single_top_',num2str(n),'_',outs), 'w');
% for i=1:n
%    fprintf(fidn,'%s %s \n', num2str( justids(ind(i))), num2str(lof(i)) );   
% end
% fclose(fidn);
% 
% disp('TOPs are written! Press ENTER to continue...\n')










h = figure;
hold all

title(name)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dcm_obj = datacursormode(h);
set(dcm_obj,'SnapToDataVertex','off','Enable','on', 'UpdateFcn',@myupdatefcn)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

labels = {'in-degree', 'out-degree', 'W_{in}', 'W_{out}', 'max(W_{in})', 'max(W_{out})', '|W_{1G}|', 'max(W_{1G})', '|E_{1G}|', ...
    'N_{in-degree=1}', 'N_{out-degree=1}', 'max(N_{out-degree=1})','max(N_{in-degree=1})','max(N_{in-degree})', ...
    'max(N_{out-degree})','|V_{1G}|','\lambda_1', '\lambda_{1,w}'};





if (isline)
    


outliernessp = textread( strcat(name,'_',num2str(props(1)),'_',num2str(props(2)),'_scores_p'));
outliernessp = outliernessp(:,2);

% find max n outliers
indp = [];
lofp = zeros(n,1);

[lofd, indd] = max(outliernessp);
lofp(1) = lofd(1);

indd = find(outliernessp == lofp(1));
outliernessp(indd) = 0;

indp = [indp; indd];

no=2;
while(1)    
    [lofd, indd] = max(outliernessp);
    lofp(no) = lofd(1);
    
    indd = find(outliernessp == lofp(no));
    outliernessp(indd) = 0;
    
    indp = [indp; indd];
    
    if (lof(no) ~= lof(no-1))
        no = no+1;
        if(no == n+1)
            break;
        end
    end
    
end



   
    
    
    
    
    
% bucketize
mult = 1;
base = 2;
buc = 0;

indx = find(noids(:,props(1)) > 0 & noids(:,props(2)) > 0); % ignore negative valued nodes


edge_w = noids(indx,props(1));
mul_deg = noids(indx,props(2));

% find number of buckets
sumin = 1;
maxx = max(edge_w-min(edge_w)+1);
while (sumin < maxx)
    sumin = sumin + (base^buc) * mult;
    buc = buc+1;
end

middledegrees = zeros(buc,1);
mediandeg = zeros(buc,1);

bucno = 0;
start = min(edge_w);
cur = 1;
for t=1:buc
    endd = start+ (base^bucno) * mult;
%     yl = ylim;
%     q = ones(yl(2),1);
%     q = cumsum(q);
%     q2 = ones(yl(2),1);
%     q2 = q2*endd;
%     line(q2,q,'color','r') 
    indices = find(  edge_w >= start & edge_w < endd  );
   
    if ( ~isempty(indices) )
        m = mul_deg(indices);
        curedge_w = edge_w(indices);
        
        med = median(  m ) ;          
        [min_difference, in_indices] = min(abs(m - med));        
        mediandeg(cur) = m(in_indices(1));
        
        [sm si] = sort(m);
        curedge_w = curedge_w(si);
        mid = ceil(length(indices)/2);
        in_indices2 = find(sm == mediandeg(cur));
        [min_difference, medind] = min(abs(in_indices2 - mid));
        middledegrees(cur) = curedge_w(in_indices2(medind(1))); %(start+endd)/2;
 
        cur = cur+1;
        
    end
    start = endd;
    bucno = bucno+1;
end

numnonemptybucs = cur-2;
numnonemptybucs2 = cur-2;
middledegrees2 = middledegrees(2:numnonemptybucs2);
mediandeg2 = mediandeg(2:numnonemptybucs2);


middledegrees = middledegrees(1:numnonemptybucs);
mediandeg = mediandeg(1:numnonemptybucs);



H = (log10(mediandeg2));
t = (log10(middledegrees2));
wi = [ones(length(t),1) t]\H;
y = wi(2) * log10(middledegrees) + wi(1);
loglog( 10.^log10(middledegrees), 10.^y, 'r-', 'LineWidth',2 )
legendss{1} = strcat( num2str(wi(2)) , 'x + (' , num2str(wi(1)), ') = y' ); 

if (limits == 1) % for E vs N
    % TREE-LIKE
    t = (log10(middledegrees2));
    H = (log10(middledegrees2-1));
    w = [ones(length(t),1) t]\H;
    y2 = w(2) * log10(middledegrees) + w(1);    
    loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 

    % CLIQUE
    t = (log10(middledegrees2));
    H = (log10(( middledegrees2-1).*middledegrees2 / 2));
    w = [ones(length(t),1) t]\H;
    y3 = w(2) * log10(middledegrees) + w(1);   
    loglog( 10.^log10(middledegrees), 10.^y3, 'b--', 'LineWidth',1 )
    legendss{3} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 
end
if (limits == 2) % for lambda_1 vs E
    % STAR
    t = (log10(middledegrees2));
    H = (log10(sqrt(middledegrees2)));
    w = [ones(length(t),1) t]\H;
    y2 = w(2) * log10(middledegrees) + w(1);  
    loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 

    % CLIQUE
    t = (log10(mediandeg2.*(mediandeg2+1)/2));
    H = (log10(mediandeg2));
    w = [ones(length(t),1) t]\H;
    y3 = w(2) * log10(middledegrees) + w(1);
    loglog( 10.^log10(middledegrees), 10.^y3, 'b--', 'LineWidth',1 )
    legendss{3} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 
    
   
end


if (limits == 3) % for lambda_w1 vs W
    % uniform slope = 0.5
    t = (log10(middledegrees2));
    H = (log10(sqrt(middledegrees2)));
    w = [ones(length(t),1) t]\H;
    y2 = w(2) * log10(middledegrees) + w(1);  
    loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 

    % 1 burst slope = 1
    t = (log10(middledegrees2));
    H = (log10(middledegrees2));
    w = [ones(length(t),1) t]\H;
    y3 = w(2) * log10(middledegrees) + w(1);  
    loglog( 10.^log10(middledegrees), 10.^y3, 'b--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' );  
    
   
end

if (limits == 4) % for W vs E
 
    t = (log10(middledegrees2));
    H = (log10(middledegrees2));
    w = [ones(length(t),1) t]\H;
    y2 = w(2) * log10(middledegrees) + w(1);  
    loglog( 10.^log10(middledegrees), 10.^y2, 'b--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' );  
    
   
end

legend(legendss, 'FontSize', 11,2)

loglog(noids(:,props(1)),noids(:,props(2)),... %'g.') %,'color',[0 1 0]*0.8)
    'LineStyle','none','Marker','o','MarkerSize',2,'MarkerEdgeColor','g','MarkerFaceColor','g');
loglog(  middledegrees, mediandeg, 'o','Markersize',5, 'MarkerEdgeColor','k',...
              'MarkerFaceColor','k');
loglog( 10.^log10(middledegrees), 10.^y, 'r-', 'LineWidth',2 )             
if (limits < 4 && limits > 0)   
loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
loglog( 10.^log10(middledegrees), 10.^y3, 'b--', 'LineWidth',1 )
end
if (limits == 4)   
loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
end



% put bucket signs!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
% start = min(edge_w);
% bucno = 0;
% for t=1:buc
%     endd = start+ (base^bucno) * mult;
%     yl = ylim;
%     
%     q = cumsum(ones(yl(2),1));
%     q2 = ones(yl(2),1);
%     q2 = q2*endd;
%     line(q2,q,'color',[.7,.7,.7], 'Linestyle',':', 'LineWidth',.5 ) 
%     
%     start = endd;
%     bucno = bucno+1;
% end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% find the top-n most away from below and above
edge_w = noids(:,props(1));
mul_deg = noids(:,props(2));

loglog(  edge_w(ind), mul_deg(ind),...
                'LineStyle','none','marker','^','markersize',5,'MarkerEdgeColor','y','MarkerFaceColor','y')
            
 
for o=1:n
    myind = find(indp == ind(o));
    if (length(myind) == 0)
         myind2 = find(indpl == ind(o));
         if (length(myind2) == 0) % combined
             plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','v','markersize',5,'MarkerEdgeColor','m','MarkerFaceColor','m')
             if(o==1)
                 plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','v','markersize',10,'MarkerEdgeColor','m','MarkerFaceColor','m')
             end
             if(o==2)
                 plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','v','markersize',8,'MarkerEdgeColor','m','MarkerFaceColor','m')
             end
             if(o==3)
                 plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','v','markersize',6,'MarkerEdgeColor','m','MarkerFaceColor','m')
             end
             
         else % only LOF
             plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','<','markersize',5,'MarkerEdgeColor','b','MarkerFaceColor','b')
             if(o==1)
                 plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','<','markersize',10,'MarkerEdgeColor','b','MarkerFaceColor','b')
             end
             if(o==2)
                 plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','<','markersize',8,'MarkerEdgeColor','b','MarkerFaceColor','b')
             end
             if(o==3)
                 plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','<','markersize',6,'MarkerEdgeColor','b','MarkerFaceColor','b')
             end
             
         end
    else
         myind2 = find(indpl == ind(o));
         if (length(myind2) == 0) % only DIST
             plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','>','markersize',5,'MarkerEdgeColor','k','MarkerFaceColor','k')
             if(o==1)
                 plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','>','markersize',10,'MarkerEdgeColor','k','MarkerFaceColor','k')
             end
             if(o==2)
                 plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','>','markersize',8,'MarkerEdgeColor','k','MarkerFaceColor','k')
             end
             if(o==3)
                 plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','>','markersize',6,'MarkerEdgeColor','k','MarkerFaceColor','k')
             end
             
         else % both found it
             plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','^','markersize',5,'MarkerEdgeColor','r','MarkerFaceColor','r')
             if(o==1)
                 plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','^','markersize',10,'MarkerEdgeColor','r','MarkerFaceColor','r')
             end
             if(o==2)
                 plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','^','markersize',8,'MarkerEdgeColor','r','MarkerFaceColor','r')
             end
             if(o==3)
                 plot(edge_w(ind(o)), mul_deg(ind(o)), ...
                    'LineStyle','none','marker','^','markersize',6,'MarkerEdgeColor','r','MarkerFaceColor','r')
             end
             
         end
        
    end
    
    
end
  


else
    loglog(noids(:,props(1)),noids(:,props(2)),... %'g.') %,'color',[0 1 0]*0.8)
    'LineStyle','none','Marker','o','MarkerSize',2,'MarkerEdgeColor','g','MarkerFaceColor','g');


    loglog(  noids(indpl,props(1)),noids(indpl,props(2)),...
                'LineStyle','none','marker','^','markersize',5,'MarkerEdgeColor','r','MarkerFaceColor','r')
            
    plot(noids(indpl_sin(1),props(1)),noids(indpl_sin(1),props(2)),...
        'LineStyle','none','marker','^','markersize',10,'MarkerEdgeColor','m','MarkerFaceColor','m')
    plot(noids(indpl_sin(2),props(2)),noids(indpl_sin(2),props(2)),...
        'LineStyle','none','marker','^','markersize',8,'MarkerEdgeColor','m','MarkerFaceColor','m')
    plot(noids(indpl_sin(3),props(1)),noids(indpl_sin(3),props(2)),...
        'LineStyle','none','marker','^','markersize',6,'MarkerEdgeColor','m','MarkerFaceColor','m')


        
end
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

set(gca,'XScale','log')
set(gca,'YScale','log')
xlabel(labels(props(1)),'FontSize', 16)
ylabel(labels(props(2)),'FontSize', 16)
set(gcf,'PaperPositionMode','auto')
hgsave(strcat('plots','/',name,'_combined_',num2str(props(1)),'_',num2str(props(2)), '.fig'))


















% 
% 
% 
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function txt = myupdatefcn(empt,event_obj)
% pos = get(event_obj,'Position');
% indd = find( noids(:,props(1)) == pos(1) & noids(:,props(2)) == pos(2) );
% txt = {num2str(justids(indd))};
% %text(pos(1),pos(2),txt)
% plot(pos(1),pos(2),'b.','marker','o','markersize',6)
% % fid = fopen( namen, 'a');
% % for g=1:length(indd)
% %    fprintf(fid,'%s\n', num2str(datum(indd(g),3)) ); 
% % end
% % 
% % fclose(fid);
% end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

end