function merge_ranks(name, props)

% merge two ranked lists
data1 = textread( strcat(name,'_',props,'_scores_p'));
data2 = textread( strcat(name,'_',props,'_scores_l'));


[val ind1] = sort(data1(:,2),'descend');
[val ind2] = sort(data2(:,2),'descend');

ranks1 = data1(ind1,1);
ranks2 = data2(ind2,1);


newrank = [];

for i=1:size(data1,1) 
    ix = find(newrank == ranks1(i));
    if(length(ix) == 0)
        newrank = [newrank ranks1(i)];
    end
    ix = find(newrank == ranks2(i));
    if(length(ix) == 0)
        newrank = [newrank ranks2(i)];
    end
end

l = length(newrank);


fid = fopen( strcat('ranks/',name,'_',props,'_ranklist'), 'w');
for i=1:l
    fprintf(fid,'%s\n', num2str(newrank(i)) );   
end
fclose(fid);


fid = fopen( strcat(name,'_',props,'_finalscore'), 'w');
for i=1:size(data1,1) 
    ix = find(newrank == data1(i,1));
    fprintf(fid,'%s %s\n', num2str(data1(i,1)), num2str(l-ix) );   
end
fclose(fid);

end