#!/usr/bin/python



import os
import random
import string
import sys
import time
import pylab as P
import networkx as  NX
import numpy 
from Numeric import *

def calcSigmas(gIn):

	A=NX.adj_matrix(gIn)
	
	decomp= numpy.linalg.svd(A)
	s=decomp[1]

	#print len(s)
	return s[0]

def calcEffDiam(gIn):
        bigcomp = NX.connected_component_subgraphs(gIn)[0]
        samplesize=500
        pathlength = zeros(samplesize)
        cnodes = bigcomp.nodes()
        for i in range(samplesize):
            x = random.randint(0,bigcomp.order()-1)
            y = random.randint(0,bigcomp.order()-1)
            while (y == x):
	          y = random.randint(0,bigcomp.order()-1)

            pathlength[i] = NX.shortest_path_length(bigcomp,cnodes[x],cnodes[y])
        pathlength = list(pathlength)
        pathlength.sort()
        #print pathlength
        return pathlength.pop(90)

# to detect chains, might take long!
def calcEffLocalRadius(gIn, mynode):
        compnodes = NX.node_connected_component(gIn, mynode) 
	if ( len(compnodes) == 1 ):
		return 0

	bigcomp = gIn.subgraph(compnodes)

        samplesize=100
        pathlength = zeros(samplesize)
        cnodes = bigcomp.nodes()
        for i in range(samplesize):
	     y = random.randint(0,bigcomp.order()-1)
             while (cnodes[y] == mynode):
	          y = random.randint(0,bigcomp.order()-1)

             pathlength[i] = NX.shortest_path_length(bigcomp,mynode,cnodes[y])

        pathlength = list(pathlength)
        pathlength.sort()
        #print pathlength
        return pathlength.pop(90)




grname = sys.argv[1]
foldername = sys.argv[2]

try:
	
        fp = open(grname,"r")
	outfp = open(foldername+'.nn1',"w")
	outfp2 = open(foldername+'.nodelist',"w")
	

except:
	print "could not load ", fname, " - quitting"
	sys.exit(-2)
	
allgr=NX.XDiGraph()
#gr.allow_multiedges()

print "loading ", grname

# construct the graph
for line in fp.readlines():
    
    inpList=string.split(line)
    assert (len(inpList)==3)

     
    src = inpList[0]
    dst = inpList[1]
    numpack = inpList[2]
    
   
    if (allgr.has_edge(src, dst)):
	ed = allgr.get_edge(src,dst)		
	allgr.delete_edge(src,dst)
	allgr.add_edge(src,dst,ed+float(numpack))
    else:
	allgr.add_edge(src,dst,float(numpack))
	

print 'graph constructed!'
fp.close()


allnodes = allgr.nodes()

for line in allnodes:

    outfp2.write( str(line) +  '\n')
    outfp2.flush()

    nodefp = open(foldername+'/'+line+'.nn1',"r")

    mynodes = nodefp.readlines()
    if (len(mynodes) == 0): # singleton
	#print 'SINGLETON'
    	outfp.write( str(line) + ' ' + str(0) + ' ' + str(0) + ' ' + str(0) + ' '+ str(0) 
		    				  + ' ' +  str(0) + ' ' + str(0) + ' '
					          + str(0) + ' ' + str(0) + ' ' + str(0) + ' ' 
						  + str(0) + ' ' + str(0) + ' ' 
						  + str(0) + ' ' + str(0) + ' ' 
						  + str(0) + ' ' + str(0) + '\n')    	
	outfp.flush()
	continue


    gr=NX.XDiGraph()
    for lines in mynodes: 
    	inpList=string.split(lines)
    	
    	src = inpList[0]
    	dst = inpList[1] 
	w = inpList[2]	
   
    	gr.add_edge(src,dst,w)

    # local properties ------------------------------------------------  degree / / total-weight / max-weight
    in_degree = gr.in_degree(line)
    out_degree = gr.out_degree(line)
    #effradius = calcEffLocalRadius(allgr, line)

    in_weights = list()
    in_weights.append(0)
    node_in_weight = 0
    src_in_edges = gr.in_edges(line)
	
    for initem in src_in_edges:
	node_in_weight  = node_in_weight + float(initem[2])
	in_weights.append(float(initem[2]))

    max_in_w = max(in_weights)

    out_weights = list()
    out_weights.append(0)
    node_out_weight = 0
    src_out_edges = gr.out_edges(line)
	
    for outitem in src_out_edges:
	node_out_weight  = node_out_weight + float(outitem[2])
	out_weights.append(float(outitem[2]))

    max_out_w = max(out_weights)



    # global properties subgr ---------------------------------------------- numnodes / numedges /  totalweight / maxweight 
    edge_weights = list()
    subgr_weight = 0
    subgr_edges = gr.edges()
	
    for item in subgr_edges:
	subgr_weight  = subgr_weight + float(item[2])
	edge_weights.append(float(item[2]))

    max_edgew = max(edge_weights)
		
    #effdiam = calcEffDiam(gr)
    
    numnodes = gr.number_of_nodes()
    ugr = gr.to_undirected()
    numedges = ugr.number_of_edges()
    
    #prineig = calcSigmas(gr)

    # neighboring nodes properties --------- num_neighs w/ degree 1 / max neigh_degree 
    
    in_deg_neigh = list()
    in_amount_neigh1 = list()
    in_amount_neigh1.append(0)    
    in_deg1 = 0

    out_deg_neigh = list()
    out_amount_neigh1 = list()
    out_amount_neigh1.append(0)    
    out_deg1 = 0


    anodes= gr.out_neighbors(line)
    anodes2= gr.in_neighbors(line)
    anodes.extend(anodes2)

    firstneighborlist = list(set(anodes))

    #if(len(firstneighborlist) == numnodes-1 ):
	#raw_input("Hit Enter to continue: ")

   
    for nh in firstneighborlist:
	in_degr = allgr.in_degree(nh)
	in_deg_neigh.append(float(in_degr))

	out_degr = allgr.out_degree(nh)
	out_deg_neigh.append(float(out_degr))
	if in_degr==1:
		if (gr.has_edge(line, nh)): # me -> nh out-neighbor
			in_deg1 = in_deg1+1
			ed = gr.get_edge(line,nh)
                	out_amount_neigh1.append(float(ed))

	if out_degr==1:
		if (gr.has_edge(nh, line)): # me <- nh in-neighbor
			out_deg1 = out_deg1+1
			ed = gr.get_edge(nh, line)
                	in_amount_neigh1.append(float(ed))

    max_in_degr = max(in_deg_neigh)
    max_out_degr = max(out_deg_neigh)
    max_in_amount_deg1 = max(in_amount_neigh1)
    max_out_amount_deg1 = max(out_amount_neigh1)
    
    outfp.write( str(line) + ' ' + str(in_degree) + ' ' + str(out_degree) + ' ' + str(node_in_weight) + ' '+ str(node_out_weight) 
		    				  + ' ' +  str(max_in_w) + ' ' + str(max_out_w) + ' '
					          + str(subgr_weight) + ' ' + str(max_edgew) + ' ' + str(numedges) + ' ' 
						  + str(in_deg1) + ' ' + str(out_deg1) + ' ' 
						  + str(max_in_amount_deg1) + ' ' + str(max_out_amount_deg1) + ' ' 
						  + str(max_in_degr) + ' ' + str(max_out_degr) + ' ' + str(numnodes) + '\n')
    outfp.flush()
    

outfp.close()
outfp2.close()

