function outlof(name, props, n)

flag=2;

% read the whole data with ALL features
data1 = textread(strcat(name,'.nn1')); % nn 
data2 = textread(strcat('eigs_',name,'.txt')); % eigs

alldata = [data1 abs(data2(:,2:3))];


noids = alldata(:,2:size(alldata,2));
justids = alldata(:,1);

% read unique data
%data = textread(uniqfile);
nodeids = textread(strcat(name,'_',num2str(props(1)),'_',num2str(props(2)), '_unique_ids'));
data = textread(strcat(name,'_',num2str(props(1)),'_',num2str(props(2)), '_unique'));

outlierness = textread( strcat('lof_',num2str(props(1)),'_',num2str(props(2)), '.txt') );


%%%%%%%%%%%%%%%
fid = fopen( strcat(name,'_',num2str(props(1)),'_',num2str(props(2)),'_scores_l'), 'w');
alloutscores = zeros(length(justids),1);

% look at the computed ones 1-by-1 and find same tuples in all data
for i=1:length(nodeids)    
    
   indices = find(  noids(:,props(1)) ==data(i,1) & ...
                    noids(:,props(2)) == data(i,2) );   
               
   alloutscores(indices) = outlierness(i); 
end
for a=1:length(justids)
    fprintf(fid,'%s %s\n', num2str(justids(a)), num2str( alloutscores(a) )); 
end
fclose(fid);





% find max n outliers
ind = zeros(n,1);
lof = zeros(n,1);

[lofd, indd] = max(outlierness);
ind(1) = indd(1);
lof(1) = lofd(1);

indd = find(outlierness == lof(1));
outlierness(indd) = 0;

no=2;
while(1)    
    [lofd, indd] = max(outlierness);
    ind(no) = indd(1);
    lof(no) = lofd(1);
    
    indd = find(outlierness == lof(no));
    outlierness(indd) = 0;
    
    if (lof(no) ~= lof(no-1))
        no = no+1;
        if(no == n+1)
            break;
        end
    end
    
end




 fidn = fopen( strcat('single_top_',num2str(n),'_','lof_',num2str(props(1)),'_',num2str(props(2)), '.txt') , 'w');
% fidnall = fopen( strcat('all_top_',num2str(n),'_',outs), 'w');

outlierness = textread( strcat('lof_',num2str(props(1)),'_',num2str(props(2)), '.txt') );

topind = [];
for i=1:n
    
   indice = find( outlierness == outlierness(ind(i))  );
   
   allnodes = [];
   for k=1:length(indice)
        nodeid = nodeids(indice(k));
        indx = find( justids == nodeid );
   
        indices = find(  noids(:,props(1)) == noids(indx,props(1)) & ...
                    noids(:,props(2)) == noids(indx,props(2)) );
%                     noids(:,3) == noids(indx,3) & ...
%                     noids(:,4) == noids(indx,4) & ...
%                     noids(:,5) == noids(indx,5) & ...
%                     noids(:,6) == noids(indx,6) & ...
%                     noids(:,7) == noids(indx,7) & ...
%                     noids(:,8) == noids(indx,8) & ...
%                     noids(:,9) == noids(indx,9) & ...
%                     noids(:,10) == noids(indx,10) & ...
%                     noids(:,11) == noids(indx,11)  ...
                
   
        %disp( strcat('lof: ', num2str(lof(i)) ) )
        %alldata(indices,1)
        allnodes = [allnodes ; alldata(indices,1)];
   end
   
   uallnodes = unique(allnodes);

   
   
   
%    for a=1:length(uallnodes)
%         fprintf(fidnall,'%s %s %s\n', num2str(i), num2str( uallnodes(a) ), num2str(lof(i)) ); 
%    end
    fprintf(fidn,'%s %s %s\n', num2str( uallnodes(1) ), num2str(lof(i)), num2str( length(uallnodes) )  );
   topind = [topind; find(justids == uallnodes(1))];
   
end
 fclose(fidn);
% fclose(fidnall);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%
labels = {'in-degree', 'out-degree', 'W_{in}', 'W_{out}', 'max(W_{in})', 'max(W_{out})', '|W_{1G}|', 'max(W_{1G})', '|E_{1G}|', ...
    'N_{in-degree=1}', 'N_{out-degree=1}', 'max(N_{out-degree=1})','max(N_{in-degree=1})','max(N_{in-degree})', ...
    'max(N_{out-degree})','|V_{1G}|','\lambda_1', '\lambda_{1,w}'};

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
datum = [noids(:,props(1)) noids(:,props(2)) justids];


%namen = strcat('badnodes_',name,'_',num2str(props(1)),'_',num2str(props(2)));
%fid = fopen( namen, 'w');
%fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if (flag == 3)
figure


title(name)
plot3(noids(:,props(1)),noids(:,props(2)),noids(:,props(3)), ...
    'LineStyle','none','Marker','o','MarkerSize',1.5,'MarkerEdgeColor','k','MarkerFaceColor','k');

hold all
%-------------- sign
plot3(noids(ind,props(1)),noids(ind,props(2)),noids(ind,props(3)), ...
    'LineStyle','none','marker','o','markersize',3,'MarkerEdgeColor','r','MarkerFaceColor','r')
%text(allprop(ind,props(1)),allprop(ind,props(2)),allprop(ind,props(3)), num2str(justids(ind)))
%--------------------
set(gca,'XScale','log')
set(gca,'YScale','log')
set(gca,'ZScale','log')
xlabel(labels(props(1)))
ylabel(labels(props(2)))
zlabel(labels(props(3)))


else

h = figure;
hold all

title(name)
plot(datum(:,1),datum(:,2),...
    'LineStyle','none','Marker','o','MarkerSize',2,'MarkerEdgeColor','g','MarkerFaceColor','g');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dcm_obj = datacursormode(h);
set(dcm_obj,'SnapToDataVertex','off','Enable','on', 'UpdateFcn',@myupdatefcn)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%-------------- sign
plot(datum(topind,1),datum(topind,2), ...
    'LineStyle','none','marker','^','markersize',5,'MarkerEdgeColor','r','MarkerFaceColor','r')
plot(datum(topind(1),1),datum(topind(1),2), ...
    'LineStyle','none','marker','^','markersize',10,'MarkerEdgeColor','k','MarkerFaceColor','k')
plot(datum(topind(2),1),datum(topind(2),2), ...
    'LineStyle','none','marker','^','markersize',8,'MarkerEdgeColor','b','MarkerFaceColor','b')
plot(datum(topind(3),1),datum(topind(3),2), ...
    'LineStyle','none','marker','^','markersize',6,'MarkerEdgeColor','m','MarkerFaceColor','m')
%text(allprop(ind,props(1)),allprop(ind,props(2)), num2str(justids(ind)))
%--------------------

set(gca,'XScale','log')
set(gca,'YScale','log')
xlabel(labels(props(1)),'FontSize', 16)
ylabel(labels(props(2)),'FontSize', 16)
set(gcf,'PaperPositionMode','auto')
hgsave(strcat('plots','/',name,'_outlof_',num2str(props(1)),'_',num2str(props(2)), '.fig'))

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function txt = myupdatefcn(empt,event_obj)
pos = get(event_obj,'Position');
indd = find( datum(:,1) == pos(1) & datum(:,2) == pos(2) );
txt = {num2str(datum(indd,3))};
text(pos(1),pos(2),num2str(datum(ind,3)))
plot(pos(1),pos(2),'b.','marker','o','markersize',6)
fid = fopen( namen, 'a');
for t=1:length(indd)
   fprintf(fid,'%s\n', num2str(datum(indd(t),3)) ); 
end

fclose(fid);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

end