function effective(name, props, k, istext, limits, isline)

data1 = textread(strcat(name,'.nn1')); % nn 
data2 = textread(strcat('eigs_',name,'.txt')); % eigs

data = [data1 abs(data2(:,2:3))];

indx = find(data(:,props(1)+1) > 0 & data(:,props(2))+1 > 0); % ignore negative or 0 valued nodes
% 
% 
nodeids = data(indx,1);
% 
% indegree = data(indx,2);
% outdegree = data(indx,3);
% node_inw = data(indx,4);
% node_outw = data(indx,5);
% max_inw = data(indx,6);
% max_outw = data(indx,7);
% 
% subgr_w = data(indx,8);
% max_edgew = data(indx,9);
% numedges = data(indx,10)
% 
% deg1 = data(indx,9);
% max_nh_deg = data(indx,10);
% maxw_nh_deg1 = data(indx,11);
% 
% prineig = abs(data(indx,12));
% w_prineig = abs(data(indx,13));
% 
% effradius = zeros(length(degree),1);

            % 17 features      
allprop = data(indx,2:size(data,2));


labels = {'in-degree', 'out-degree', 'W_{in}', 'W_{out}', 'max(W_{in})', 'max(W_{out})', '|W_{1G}|', 'max(W_{1G})', '|E_{1G}|', ...
    'N_{in-degree=1}', 'N_{out-degree=1}', 'max(N_{out-degree=1})','max(N_{in-degree=1})','max(N_{in-degree})', ...
    'max(N_{out-degree})','|V_{1G}|','\lambda_1', '\lambda_{1,w}'};


figure
hold all

title(name)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if (isline)
% bucketize
mult = 1;
base = 2;
buc = 0;

edge_w = allprop(:,props(1));
mul_deg = allprop(:,props(2));


% find number of buckets
sumin = 1;
maxx = max(edge_w-min(edge_w)+1);
while (sumin < maxx)
    sumin = sumin + (base^buc) * mult;
    buc = buc+1;
end

middledegrees = zeros(buc,1);
mediandeg = zeros(buc,1);

bucno = 0;
start = min(edge_w);
cur = 1;
for t=1:buc
    endd = start+ (base^bucno) * mult;

    indices = find(  edge_w >= start & edge_w < endd  );
   
    if ( ~isempty(indices) )
        m = mul_deg(indices);
        curedge_w = edge_w(indices);
        
        med = median(  m ) ;          
        [min_difference, in_indices] = min(abs(m - med));        
        mediandeg(cur) = m(in_indices(1));
        
        [sm si] = sort(m);
        curedge_w = curedge_w(si);
        mid = ceil(length(indices)/2);
        in_indices2 = find(sm == mediandeg(cur));
        [min_difference, medind] = min(abs(in_indices2 - mid));
        middledegrees(cur) = curedge_w(in_indices2(medind(1))); %(start+endd)/2;
 
        cur = cur+1;
        
    end
    start = endd;
    bucno = bucno+1;
end

numnonemptybucs = cur-2;
numnonemptybucs2 = cur-2;
middledegrees2 = middledegrees(2:numnonemptybucs2);
mediandeg2 = mediandeg(2:numnonemptybucs2);


middledegrees = middledegrees(1:numnonemptybucs);
mediandeg = mediandeg(1:numnonemptybucs);



H = (log10(mediandeg2));
t = (log10(middledegrees2));
wi = [ones(length(t),1) t]\H;
y = wi(2) * log10(middledegrees) + wi(1);
loglog( 10.^log10(middledegrees), 10.^y, 'r-', 'LineWidth',2 )
legendss{1} = strcat( num2str(wi(2)) , 'x + (' , num2str(wi(1)), ') = y' ); 

if (limits == 1) % for E vs N
    % TREE-LIKE
    t = (log10(middledegrees2));
    H = (log10(middledegrees2-1));
    w = [ones(length(t),1) t]\H;
    y2 = w(2) * log10(middledegrees) + w(1);    
    loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 

    % CLIQUE
    t = (log10(middledegrees2));
    H = (log10(( middledegrees2-1).*middledegrees2 / 2));
    w = [ones(length(t),1) t]\H;
    y3 = w(2) * log10(middledegrees) + w(1);   
    loglog( 10.^log10(middledegrees), 10.^y3, 'b--', 'LineWidth',1 )
    legendss{3} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 
end
if (limits == 2) % for lambda_1 vs E
    % STAR
    t = (log10(middledegrees2));
    H = (log10(sqrt(middledegrees2)));
    w = [ones(length(t),1) t]\H;
    y2 = w(2) * log10(middledegrees) + w(1);  
    loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 

    % CLIQUE
    t = (log10(mediandeg2.*(mediandeg2+1)/2));
    H = (log10(mediandeg2));
    w = [ones(length(t),1) t]\H;
    y3 = w(2) * log10(middledegrees) + w(1);
    loglog( 10.^log10(middledegrees), 10.^y3, 'b--', 'LineWidth',1 )
    legendss{3} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 
    
   
end


if (limits == 3) % for lambda_w1 vs W
    % uniform slope = 0.5
    t = (log10(middledegrees2));
    H = (log10(sqrt(middledegrees2)));
    w = [ones(length(t),1) t]\H;
    y2 = w(2) * log10(middledegrees) + w(1);  
    loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' ); 

    % 1 burst slope = 1
    t = (log10(middledegrees2));
    H = (log10(middledegrees2));
    w = [ones(length(t),1) t]\H;
    y3 = w(2) * log10(middledegrees) + w(1);  
    loglog( 10.^log10(middledegrees), 10.^y3, 'b--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' );  
    
   
end

if (limits == 4) % for W vs E
 
    t = (log10(middledegrees2));
    H = (log10(middledegrees2));
    w = [ones(length(t),1) t]\H;
    y2 = w(2) * log10(middledegrees) + w(1);  
    loglog( 10.^log10(middledegrees), 10.^y2, 'b--', 'LineWidth',1 )
    legendss{2} = strcat( num2str(w(2)) , 'x + (' , num2str(w(1)), ') = y' );  
    
   
end

legend(legendss, 'FontSize', 11,2)

loglog(allprop(:,props(1)),allprop(:,props(2)),... %'g.') %,'color',[0 1 0]*0.8)
    'LineStyle','none','Marker','o','MarkerSize',2,'MarkerEdgeColor','g','MarkerFaceColor','g');
loglog(  middledegrees, mediandeg, 'o','Markersize',5, 'MarkerEdgeColor','k',...
              'MarkerFaceColor','k');
loglog( 10.^log10(middledegrees), 10.^y, 'r-', 'LineWidth',2 )             
if (limits < 4 && limits > 0)   
loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
loglog( 10.^log10(middledegrees), 10.^y3, 'b--', 'LineWidth',1 )
end
if (limits == 4)   
loglog( 10.^log10(middledegrees), 10.^y2, 'k--', 'LineWidth',1 )
end


% % put bucket signs!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
% start = min(edge_w);
% bucno = 0;
% for t=1:buc
%     endd = start+ (base^bucno) * mult;
%     yl = ylim;
%     q = ones(yl(2),1);
%     q = cumsum(q);
%     q2 = ones(yl(2),1);
%     q2 = q2*endd;
%     line(q2,q,'color',[.7,.7,.7], 'Linestyle',':', 'LineWidth',.5 ) 
%     
%     start = endd;
%     bucno = bucno+1;
% end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% find the top-n most away from below and above
siz = size(data,1);
siz2 = length(edge_w);

differ = zeros(siz2,1);
siz2ind = 1;


fid = fopen( strcat(name,'_',num2str(props(1)),'_',num2str(props(2)),'_scores_p'), 'w');

for d=1:siz
    
   if (data(d,props(1)+1) > 0 && data(d,props(2))+1 > 0)
       
       r = (mul_deg(siz2ind) / (  (edge_w(siz2ind))^wi(2) * 10^wi(1) ));
       differ(siz2ind) = max( r, 1/r); % / (edge_w(d))^wi(2) * 10^wi(1); 

       
       fprintf(fid,'%s %s\n', num2str(data(d,1)), num2str( differ(siz2ind) )); 
       
       siz2ind = siz2ind+1;
   % else do nothing, value remains 0.
   else
       fprintf(fid,'%s %s\n', num2str(data(d,1)), '0'); 
   end
end
fclose(fid);



[sortdiffer ind] = sort(differ,'descend');

fid2 = fopen( strcat('most_', num2str(props(1)),'_',num2str(props(2)),'_',num2str(k)), 'w');

[usortdiffer ind2] = unique(sortdiffer);



ind = ind(ind2);
siz = length(usortdiffer);

nodeind = ind(siz-k+1:siz) ;
usortdiffertop = usortdiffer(siz-k+1:siz);

loglog(  edge_w(nodeind), mul_deg(nodeind),...
                'LineStyle','none','marker','^','markersize',5,'MarkerEdgeColor','r','MarkerFaceColor','r')
plot(edge_w(nodeind(k)), mul_deg(nodeind(k)), ...
    'LineStyle','none','marker','^','markersize',10,'MarkerEdgeColor','k','MarkerFaceColor','k')
plot(edge_w(nodeind(k-1)), mul_deg(nodeind(k-1)), ...
    'LineStyle','none','marker','^','markersize',8,'MarkerEdgeColor','b','MarkerFaceColor','b')
plot(edge_w(nodeind(k-2)), mul_deg(nodeind(k-2)), ...
    'LineStyle','none','marker','^','markersize',6,'MarkerEdgeColor','m','MarkerFaceColor','m')

if(istext)            
    text(edge_w(nodeind), mul_deg(nodeind),num2str(nodeids(nodeind)))    
end
for t=k:-1:1
  fprintf(fid2,'%s %s\n', num2str(nodeids( nodeind(t) )), num2str(usortdiffertop(t)) );     
end



fclose(fid2);
else
    loglog(allprop(:,props(1)),allprop(:,props(2)),... %'g.') %,'color',[0 1 0]*0.8)
    'LineStyle','none','Marker','o','MarkerSize',2,'MarkerEdgeColor','g','MarkerFaceColor','g');
end
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

set(gca,'XScale','log')
set(gca,'YScale','log')
xlabel(labels(props(1)),'FontSize', 16)
ylabel(labels(props(2)),'FontSize', 16)
%grid on
set(gcf,'PaperPositionMode','auto')
hgsave(strcat('plots','/',name,'_pattern_',num2str(props(1)),'_',num2str(props(2)), '.fig'))



end